'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _listening = require('./listening');

var _listening2 = _interopRequireDefault(_listening);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FormField = class FormField extends _listening2.default {

  constructor(_ref) {
    var _this;

    var defaultValue = _ref.defaultValue;

    _this = super();
    this.value = null;
    this.valid = true;
    this.changed = false;
    this.errorMessage = null;
    this.defaultValue = undefined;

    this.setValue = function (value) {
      _this.value = value;
      _this.trigger('change', _this);
    };

    this.setValidation = function (valid) {
      var errorMessage = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      _this.valid = valid;
      _this.errorMessage = errorMessage;
    };

    this.change = function () {
      var event = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

      if (event !== null && 'target' in event && 'value' in event.target) {
        _this.changed = true;
        _this.setValue(event.target.value);
      }
    };

    this.changeValue = function (value) {
      _this.changed = true;
      _this.setValue(value);
    };

    this.reset = function () {
      _this.changed = false;
      _this.setValue(_this.defaultValue);
    };

    this.defaultValue = defaultValue;
  }

};
exports.default = FormField;